#!gawk -f

BEGIN{
 FS=""
 gotos[-1]=0;
 gosubs[-1]=0;
}

function FindGotos(line,needle,array) {
 k=1;
 while (i=index(substr(line,k),needle)) {
  k+=i+length(needle);
  j=strtonum(substr(line,k));
  array[j]=1;
#  print needle " " j " in " ln
 }
}

{	# for each line
 line[++linenr]=$0;	#save (1-based)
 ln=strtonum($0);
 FindGotos($0,"GOTO",gotos);
 FindGotos($0,"GOSUB",gosubs);
}

END{
 for (i=1; i<=linenr; i++) {
  ln=strtonum(line[i]);
  if (gosubs[ln]) print "void L" line[i];
  else if (gotos[ln]) print line[i];
  else print gensub(/^[0-9]+/,"",1,line[i]);
 }
}
